"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ClaimDevicesByClaimCodeCommand: () => ClaimDevicesByClaimCodeCommand,
  DescribeDeviceCommand: () => DescribeDeviceCommand,
  FinalizeDeviceClaimCommand: () => FinalizeDeviceClaimCommand,
  ForbiddenException: () => ForbiddenException,
  GetDeviceMethodsCommand: () => GetDeviceMethodsCommand,
  InitiateDeviceClaimCommand: () => InitiateDeviceClaimCommand,
  InternalFailureException: () => InternalFailureException,
  InvalidRequestException: () => InvalidRequestException,
  InvokeDeviceMethodCommand: () => InvokeDeviceMethodCommand,
  IoT1ClickDevicesService: () => IoT1ClickDevicesService,
  IoT1ClickDevicesServiceClient: () => IoT1ClickDevicesServiceClient,
  IoT1ClickDevicesServiceServiceException: () => IoT1ClickDevicesServiceServiceException,
  ListDeviceEventsCommand: () => ListDeviceEventsCommand,
  ListDevicesCommand: () => ListDevicesCommand,
  ListTagsForResourceCommand: () => ListTagsForResourceCommand,
  PreconditionFailedException: () => PreconditionFailedException,
  RangeNotSatisfiableException: () => RangeNotSatisfiableException,
  ResourceConflictException: () => ResourceConflictException,
  ResourceNotFoundException: () => ResourceNotFoundException,
  TagResourceCommand: () => TagResourceCommand,
  UnclaimDeviceCommand: () => UnclaimDeviceCommand,
  UntagResourceCommand: () => UntagResourceCommand,
  UpdateDeviceStateCommand: () => UpdateDeviceStateCommand,
  __Client: () => import_smithy_client.Client
});
module.exports = __toCommonJS(src_exports);

// src/IoT1ClickDevicesServiceClient.ts
var import_middleware_host_header = require("@aws-sdk/middleware-host-header");
var import_middleware_logger = require("@aws-sdk/middleware-logger");
var import_middleware_recursion_detection = require("@aws-sdk/middleware-recursion-detection");
var import_middleware_user_agent = require("@aws-sdk/middleware-user-agent");
var import_config_resolver = require("@smithy/config-resolver");
var import_core = require("@smithy/core");
var import_middleware_content_length = require("@smithy/middleware-content-length");
var import_middleware_endpoint = require("@smithy/middleware-endpoint");
var import_middleware_retry = require("@smithy/middleware-retry");

var import_httpAuthSchemeProvider = require("./auth/httpAuthSchemeProvider");

// src/endpoint/EndpointParameters.ts
var resolveClientEndpointParameters = /* @__PURE__ */ __name((options) => {
  return {
    ...options,
    useDualstackEndpoint: options.useDualstackEndpoint ?? false,
    useFipsEndpoint: options.useFipsEndpoint ?? false,
    defaultSigningName: "iot1click"
  };
}, "resolveClientEndpointParameters");
var commonParams = {
  UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
  Endpoint: { type: "builtInParams", name: "endpoint" },
  Region: { type: "builtInParams", name: "region" },
  UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" }
};

// src/IoT1ClickDevicesServiceClient.ts
var import_runtimeConfig = require("././runtimeConfig");

// src/runtimeExtensions.ts
var import_region_config_resolver = require("@aws-sdk/region-config-resolver");
var import_protocol_http = require("@smithy/protocol-http");
var import_smithy_client = require("@smithy/smithy-client");

// src/auth/httpAuthExtensionConfiguration.ts
var getHttpAuthExtensionConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
  const _httpAuthSchemes = runtimeConfig.httpAuthSchemes;
  let _httpAuthSchemeProvider = runtimeConfig.httpAuthSchemeProvider;
  let _credentials = runtimeConfig.credentials;
  return {
    setHttpAuthScheme(httpAuthScheme) {
      const index = _httpAuthSchemes.findIndex((scheme) => scheme.schemeId === httpAuthScheme.schemeId);
      if (index === -1) {
        _httpAuthSchemes.push(httpAuthScheme);
      } else {
        _httpAuthSchemes.splice(index, 1, httpAuthScheme);
      }
    },
    httpAuthSchemes() {
      return _httpAuthSchemes;
    },
    setHttpAuthSchemeProvider(httpAuthSchemeProvider) {
      _httpAuthSchemeProvider = httpAuthSchemeProvider;
    },
    httpAuthSchemeProvider() {
      return _httpAuthSchemeProvider;
    },
    setCredentials(credentials) {
      _credentials = credentials;
    },
    credentials() {
      return _credentials;
    }
  };
}, "getHttpAuthExtensionConfiguration");
var resolveHttpAuthRuntimeConfig = /* @__PURE__ */ __name((config) => {
  return {
    httpAuthSchemes: config.httpAuthSchemes(),
    httpAuthSchemeProvider: config.httpAuthSchemeProvider(),
    credentials: config.credentials()
  };
}, "resolveHttpAuthRuntimeConfig");

// src/runtimeExtensions.ts
var asPartial = /* @__PURE__ */ __name((t) => t, "asPartial");
var resolveRuntimeExtensions = /* @__PURE__ */ __name((runtimeConfig, extensions) => {
  const extensionConfiguration = {
    ...asPartial((0, import_region_config_resolver.getAwsRegionExtensionConfiguration)(runtimeConfig)),
    ...asPartial((0, import_smithy_client.getDefaultExtensionConfiguration)(runtimeConfig)),
    ...asPartial((0, import_protocol_http.getHttpHandlerExtensionConfiguration)(runtimeConfig)),
    ...asPartial(getHttpAuthExtensionConfiguration(runtimeConfig))
  };
  extensions.forEach((extension) => extension.configure(extensionConfiguration));
  return {
    ...runtimeConfig,
    ...(0, import_region_config_resolver.resolveAwsRegionExtensionConfiguration)(extensionConfiguration),
    ...(0, import_smithy_client.resolveDefaultRuntimeConfig)(extensionConfiguration),
    ...(0, import_protocol_http.resolveHttpHandlerRuntimeConfig)(extensionConfiguration),
    ...resolveHttpAuthRuntimeConfig(extensionConfiguration)
  };
}, "resolveRuntimeExtensions");

// src/IoT1ClickDevicesServiceClient.ts
var IoT1ClickDevicesServiceClient = class extends import_smithy_client.Client {
  static {
    __name(this, "IoT1ClickDevicesServiceClient");
  }
  /**
   * The resolved configuration of IoT1ClickDevicesServiceClient class. This is resolved and normalized from the {@link IoT1ClickDevicesServiceClientConfig | constructor configuration interface}.
   */
  config;
  constructor(...[configuration]) {
    const _config_0 = (0, import_runtimeConfig.getRuntimeConfig)(configuration || {});
    const _config_1 = resolveClientEndpointParameters(_config_0);
    const _config_2 = (0, import_middleware_user_agent.resolveUserAgentConfig)(_config_1);
    const _config_3 = (0, import_middleware_retry.resolveRetryConfig)(_config_2);
    const _config_4 = (0, import_config_resolver.resolveRegionConfig)(_config_3);
    const _config_5 = (0, import_middleware_host_header.resolveHostHeaderConfig)(_config_4);
    const _config_6 = (0, import_middleware_endpoint.resolveEndpointConfig)(_config_5);
    const _config_7 = (0, import_httpAuthSchemeProvider.resolveHttpAuthSchemeConfig)(_config_6);
    const _config_8 = resolveRuntimeExtensions(_config_7, configuration?.extensions || []);
    super(_config_8);
    this.config = _config_8;
    this.middlewareStack.use((0, import_middleware_user_agent.getUserAgentPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_retry.getRetryPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_content_length.getContentLengthPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_host_header.getHostHeaderPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_logger.getLoggerPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_recursion_detection.getRecursionDetectionPlugin)(this.config));
    this.middlewareStack.use(
      (0, import_core.getHttpAuthSchemeEndpointRuleSetPlugin)(this.config, {
        httpAuthSchemeParametersProvider: import_httpAuthSchemeProvider.defaultIoT1ClickDevicesServiceHttpAuthSchemeParametersProvider,
        identityProviderConfigProvider: async (config) => new import_core.DefaultIdentityProviderConfig({
          "aws.auth#sigv4": config.credentials
        })
      })
    );
    this.middlewareStack.use((0, import_core.getHttpSigningPlugin)(this.config));
  }
  /**
   * Destroy underlying resources, like sockets. It's usually not necessary to do this.
   * However in Node.js, it's best to explicitly shut down the client's agent when it is no longer needed.
   * Otherwise, sockets might stay open for quite a long time before the server terminates them.
   */
  destroy() {
    super.destroy();
  }
};

// src/IoT1ClickDevicesService.ts


// src/commands/ClaimDevicesByClaimCodeCommand.ts

var import_middleware_serde = require("@smithy/middleware-serde");


// src/protocols/Aws_restJson1.ts
var import_core2 = require("@aws-sdk/core");



// src/models/IoT1ClickDevicesServiceServiceException.ts

var IoT1ClickDevicesServiceServiceException = class _IoT1ClickDevicesServiceServiceException extends import_smithy_client.ServiceException {
  static {
    __name(this, "IoT1ClickDevicesServiceServiceException");
  }
  /**
   * @internal
   */
  constructor(options) {
    super(options);
    Object.setPrototypeOf(this, _IoT1ClickDevicesServiceServiceException.prototype);
  }
};

// src/models/models_0.ts
var ForbiddenException = class _ForbiddenException extends IoT1ClickDevicesServiceServiceException {
  static {
    __name(this, "ForbiddenException");
  }
  name = "ForbiddenException";
  $fault = "client";
  /**
   * <p>403</p>
   * @public
   */
  Code;
  /**
   * <p>The 403 error message returned by the web server.</p>
   * @public
   */
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ForbiddenException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ForbiddenException.prototype);
    this.Code = opts.Code;
    this.Message = opts.Message;
  }
};
var InternalFailureException = class _InternalFailureException extends IoT1ClickDevicesServiceServiceException {
  static {
    __name(this, "InternalFailureException");
  }
  name = "InternalFailureException";
  $fault = "server";
  /**
   * <p>500</p>
   * @public
   */
  Code;
  /**
   * <p>The 500 error message returned by the web server.</p>
   * @public
   */
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "InternalFailureException",
      $fault: "server",
      ...opts
    });
    Object.setPrototypeOf(this, _InternalFailureException.prototype);
    this.Code = opts.Code;
    this.Message = opts.Message;
  }
};
var InvalidRequestException = class _InvalidRequestException extends IoT1ClickDevicesServiceServiceException {
  static {
    __name(this, "InvalidRequestException");
  }
  name = "InvalidRequestException";
  $fault = "client";
  /**
   * <p>400</p>
   * @public
   */
  Code;
  /**
   * <p>The 400 error message returned by the web server.</p>
   * @public
   */
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "InvalidRequestException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _InvalidRequestException.prototype);
    this.Code = opts.Code;
    this.Message = opts.Message;
  }
};
var ResourceNotFoundException = class _ResourceNotFoundException extends IoT1ClickDevicesServiceServiceException {
  static {
    __name(this, "ResourceNotFoundException");
  }
  name = "ResourceNotFoundException";
  $fault = "client";
  /**
   * <p>404</p>
   * @public
   */
  Code;
  /**
   * <p>The requested device could not be found.</p>
   * @public
   */
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ResourceNotFoundException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ResourceNotFoundException.prototype);
    this.Code = opts.Code;
    this.Message = opts.Message;
  }
};
var PreconditionFailedException = class _PreconditionFailedException extends IoT1ClickDevicesServiceServiceException {
  static {
    __name(this, "PreconditionFailedException");
  }
  name = "PreconditionFailedException";
  $fault = "client";
  /**
   * <p>412</p>
   * @public
   */
  Code;
  /**
   * <p>An error message explaining the error or its remedy.</p>
   * @public
   */
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "PreconditionFailedException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _PreconditionFailedException.prototype);
    this.Code = opts.Code;
    this.Message = opts.Message;
  }
};
var ResourceConflictException = class _ResourceConflictException extends IoT1ClickDevicesServiceServiceException {
  static {
    __name(this, "ResourceConflictException");
  }
  name = "ResourceConflictException";
  $fault = "client";
  /**
   * <p>409</p>
   * @public
   */
  Code;
  /**
   * <p>An error message explaining the error or its remedy.</p>
   * @public
   */
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ResourceConflictException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ResourceConflictException.prototype);
    this.Code = opts.Code;
    this.Message = opts.Message;
  }
};
var RangeNotSatisfiableException = class _RangeNotSatisfiableException extends IoT1ClickDevicesServiceServiceException {
  static {
    __name(this, "RangeNotSatisfiableException");
  }
  name = "RangeNotSatisfiableException";
  $fault = "client";
  /**
   * <p>416</p>
   * @public
   */
  Code;
  /**
   * <p>The requested number of results specified by nextToken cannot be
   *  satisfied.</p>
   * @public
   */
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "RangeNotSatisfiableException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _RangeNotSatisfiableException.prototype);
    this.Code = opts.Code;
    this.Message = opts.Message;
  }
};

// src/protocols/Aws_restJson1.ts
var se_ClaimDevicesByClaimCodeCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/claims/{ClaimCode}");
  b.p("ClaimCode", () => input.ClaimCode, "{ClaimCode}", false);
  let body;
  b.m("PUT").h(headers).b(body);
  return b.build();
}, "se_ClaimDevicesByClaimCodeCommand");
var se_DescribeDeviceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/devices/{DeviceId}");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  let body;
  b.m("GET").h(headers).b(body);
  return b.build();
}, "se_DescribeDeviceCommand");
var se_FinalizeDeviceClaimCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/devices/{DeviceId}/finalize-claim");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      tags: [, (_) => (0, import_smithy_client._json)(_), `Tags`]
    })
  );
  b.m("PUT").h(headers).b(body);
  return b.build();
}, "se_FinalizeDeviceClaimCommand");
var se_GetDeviceMethodsCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/devices/{DeviceId}/methods");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  let body;
  b.m("GET").h(headers).b(body);
  return b.build();
}, "se_GetDeviceMethodsCommand");
var se_InitiateDeviceClaimCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/devices/{DeviceId}/initiate-claim");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  let body;
  b.m("PUT").h(headers).b(body);
  return b.build();
}, "se_InitiateDeviceClaimCommand");
var se_InvokeDeviceMethodCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/devices/{DeviceId}/methods");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      deviceMethod: [, (_) => se_DeviceMethod(_, context), `DeviceMethod`],
      deviceMethodParameters: [, , `DeviceMethodParameters`]
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_InvokeDeviceMethodCommand");
var se_ListDeviceEventsCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/devices/{DeviceId}/events");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  const query = (0, import_smithy_client.map)({
    [_fTS]: [
      (0, import_smithy_client.expectNonNull)(input.FromTimeStamp, `FromTimeStamp`) != null,
      () => (0, import_smithy_client.serializeDateTime)(input[_FTS]).toString()
    ],
    [_mR]: [() => input.MaxResults !== void 0, () => input[_MR].toString()],
    [_nT]: [, input[_NT]],
    [_tTS]: [
      (0, import_smithy_client.expectNonNull)(input.ToTimeStamp, `ToTimeStamp`) != null,
      () => (0, import_smithy_client.serializeDateTime)(input[_TTS]).toString()
    ]
  });
  let body;
  b.m("GET").h(headers).q(query).b(body);
  return b.build();
}, "se_ListDeviceEventsCommand");
var se_ListDevicesCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/devices");
  const query = (0, import_smithy_client.map)({
    [_dT]: [, input[_DT]],
    [_mR]: [() => input.MaxResults !== void 0, () => input[_MR].toString()],
    [_nT]: [, input[_NT]]
  });
  let body;
  b.m("GET").h(headers).q(query).b(body);
  return b.build();
}, "se_ListDevicesCommand");
var se_ListTagsForResourceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/tags/{ResourceArn}");
  b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
  let body;
  b.m("GET").h(headers).b(body);
  return b.build();
}, "se_ListTagsForResourceCommand");
var se_TagResourceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/tags/{ResourceArn}");
  b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      tags: [, (_) => (0, import_smithy_client._json)(_), `Tags`]
    })
  );
  b.m("POST").h(headers).b(body);
  return b.build();
}, "se_TagResourceCommand");
var se_UnclaimDeviceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/devices/{DeviceId}/unclaim");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  let body;
  b.m("PUT").h(headers).b(body);
  return b.build();
}, "se_UnclaimDeviceCommand");
var se_UntagResourceCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {};
  b.bp("/tags/{ResourceArn}");
  b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
  const query = (0, import_smithy_client.map)({
    [_tK]: [(0, import_smithy_client.expectNonNull)(input.TagKeys, `TagKeys`) != null, () => input[_TK] || []]
  });
  let body;
  b.m("DELETE").h(headers).q(query).b(body);
  return b.build();
}, "se_UntagResourceCommand");
var se_UpdateDeviceStateCommand = /* @__PURE__ */ __name(async (input, context) => {
  const b = (0, import_core.requestBuilder)(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b.bp("/devices/{DeviceId}/state");
  b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
  let body;
  body = JSON.stringify(
    (0, import_smithy_client.take)(input, {
      enabled: [, , `Enabled`]
    })
  );
  b.m("PUT").h(headers).b(body);
  return b.build();
}, "se_UpdateDeviceStateCommand");
var de_ClaimDevicesByClaimCodeCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    ClaimCode: [, import_smithy_client.expectString, `claimCode`],
    Total: [, import_smithy_client.expectInt32, `total`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ClaimDevicesByClaimCodeCommand");
var de_DescribeDeviceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    DeviceDescription: [, (_) => de_DeviceDescription(_, context), `deviceDescription`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_DescribeDeviceCommand");
var de_FinalizeDeviceClaimCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    State: [, import_smithy_client.expectString, `state`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_FinalizeDeviceClaimCommand");
var de_GetDeviceMethodsCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    DeviceMethods: [, (_) => de___listOfDeviceMethod(_, context), `deviceMethods`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_GetDeviceMethodsCommand");
var de_InitiateDeviceClaimCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    State: [, import_smithy_client.expectString, `state`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_InitiateDeviceClaimCommand");
var de_InvokeDeviceMethodCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    DeviceMethodResponse: [, import_smithy_client.expectString, `deviceMethodResponse`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_InvokeDeviceMethodCommand");
var de_ListDeviceEventsCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    Events: [, (_) => de___listOfDeviceEvent(_, context), `events`],
    NextToken: [, import_smithy_client.expectString, `nextToken`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ListDeviceEventsCommand");
var de_ListDevicesCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    Devices: [, (_) => de___listOfDeviceDescription(_, context), `devices`],
    NextToken: [, import_smithy_client.expectString, `nextToken`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ListDevicesCommand");
var de_ListTagsForResourceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    Tags: [, import_smithy_client._json, `tags`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_ListTagsForResourceCommand");
var de_TagResourceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  await (0, import_smithy_client.collectBody)(output.body, context);
  return contents;
}, "de_TagResourceCommand");
var de_UnclaimDeviceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  const data = (0, import_smithy_client.expectNonNull)((0, import_smithy_client.expectObject)(await (0, import_core2.parseJsonBody)(output.body, context)), "body");
  const doc = (0, import_smithy_client.take)(data, {
    State: [, import_smithy_client.expectString, `state`]
  });
  Object.assign(contents, doc);
  return contents;
}, "de_UnclaimDeviceCommand");
var de_UntagResourceCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  await (0, import_smithy_client.collectBody)(output.body, context);
  return contents;
}, "de_UntagResourceCommand");
var de_UpdateDeviceStateCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = (0, import_smithy_client.map)({
    $metadata: deserializeMetadata(output)
  });
  await (0, import_smithy_client.collectBody)(output.body, context);
  return contents;
}, "de_UpdateDeviceStateCommand");
var de_CommandError = /* @__PURE__ */ __name(async (output, context) => {
  const parsedOutput = {
    ...output,
    body: await (0, import_core2.parseJsonErrorBody)(output.body, context)
  };
  const errorCode = (0, import_core2.loadRestJsonErrorCode)(output, parsedOutput.body);
  switch (errorCode) {
    case "ForbiddenException":
    case "com.amazonaws.iot1clickdevicesservice#ForbiddenException":
      throw await de_ForbiddenExceptionRes(parsedOutput, context);
    case "InternalFailureException":
    case "com.amazonaws.iot1clickdevicesservice#InternalFailureException":
      throw await de_InternalFailureExceptionRes(parsedOutput, context);
    case "InvalidRequestException":
    case "com.amazonaws.iot1clickdevicesservice#InvalidRequestException":
      throw await de_InvalidRequestExceptionRes(parsedOutput, context);
    case "ResourceNotFoundException":
    case "com.amazonaws.iot1clickdevicesservice#ResourceNotFoundException":
      throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
    case "PreconditionFailedException":
    case "com.amazonaws.iot1clickdevicesservice#PreconditionFailedException":
      throw await de_PreconditionFailedExceptionRes(parsedOutput, context);
    case "ResourceConflictException":
    case "com.amazonaws.iot1clickdevicesservice#ResourceConflictException":
      throw await de_ResourceConflictExceptionRes(parsedOutput, context);
    case "RangeNotSatisfiableException":
    case "com.amazonaws.iot1clickdevicesservice#RangeNotSatisfiableException":
      throw await de_RangeNotSatisfiableExceptionRes(parsedOutput, context);
    default:
      const parsedBody = parsedOutput.body;
      return throwDefaultError({
        output,
        parsedBody,
        errorCode
      });
  }
}, "de_CommandError");
var throwDefaultError = (0, import_smithy_client.withBaseException)(IoT1ClickDevicesServiceServiceException);
var de_ForbiddenExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    Code: [, import_smithy_client.expectString, `code`],
    Message: [, import_smithy_client.expectString, `message`]
  });
  Object.assign(contents, doc);
  const exception = new ForbiddenException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ForbiddenExceptionRes");
var de_InternalFailureExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    Code: [, import_smithy_client.expectString, `code`],
    Message: [, import_smithy_client.expectString, `message`]
  });
  Object.assign(contents, doc);
  const exception = new InternalFailureException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_InternalFailureExceptionRes");
var de_InvalidRequestExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    Code: [, import_smithy_client.expectString, `code`],
    Message: [, import_smithy_client.expectString, `message`]
  });
  Object.assign(contents, doc);
  const exception = new InvalidRequestException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_InvalidRequestExceptionRes");
var de_PreconditionFailedExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    Code: [, import_smithy_client.expectString, `code`],
    Message: [, import_smithy_client.expectString, `message`]
  });
  Object.assign(contents, doc);
  const exception = new PreconditionFailedException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_PreconditionFailedExceptionRes");
var de_RangeNotSatisfiableExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    Code: [, import_smithy_client.expectString, `code`],
    Message: [, import_smithy_client.expectString, `message`]
  });
  Object.assign(contents, doc);
  const exception = new RangeNotSatisfiableException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_RangeNotSatisfiableExceptionRes");
var de_ResourceConflictExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    Code: [, import_smithy_client.expectString, `code`],
    Message: [, import_smithy_client.expectString, `message`]
  });
  Object.assign(contents, doc);
  const exception = new ResourceConflictException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ResourceConflictExceptionRes");
var de_ResourceNotFoundExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const contents = (0, import_smithy_client.map)({});
  const data = parsedOutput.body;
  const doc = (0, import_smithy_client.take)(data, {
    Code: [, import_smithy_client.expectString, `code`],
    Message: [, import_smithy_client.expectString, `message`]
  });
  Object.assign(contents, doc);
  const exception = new ResourceNotFoundException({
    $metadata: deserializeMetadata(parsedOutput),
    ...contents
  });
  return (0, import_smithy_client.decorateServiceException)(exception, parsedOutput.body);
}, "de_ResourceNotFoundExceptionRes");
var se_DeviceMethod = /* @__PURE__ */ __name((input, context) => {
  return (0, import_smithy_client.take)(input, {
    deviceType: [, , `DeviceType`],
    methodName: [, , `MethodName`]
  });
}, "se_DeviceMethod");
var de___listOfDeviceDescription = /* @__PURE__ */ __name((output, context) => {
  const retVal = (output || []).filter((e) => e != null).map((entry) => {
    return de_DeviceDescription(entry, context);
  });
  return retVal;
}, "de___listOfDeviceDescription");
var de___listOfDeviceEvent = /* @__PURE__ */ __name((output, context) => {
  const retVal = (output || []).filter((e) => e != null).map((entry) => {
    return de_DeviceEvent(entry, context);
  });
  return retVal;
}, "de___listOfDeviceEvent");
var de___listOfDeviceMethod = /* @__PURE__ */ __name((output, context) => {
  const retVal = (output || []).filter((e) => e != null).map((entry) => {
    return de_DeviceMethod(entry, context);
  });
  return retVal;
}, "de___listOfDeviceMethod");
var de_Device = /* @__PURE__ */ __name((output, context) => {
  return (0, import_smithy_client.take)(output, {
    Attributes: [, import_smithy_client._json, `attributes`],
    DeviceId: [, import_smithy_client.expectString, `deviceId`],
    Type: [, import_smithy_client.expectString, `type`]
  });
}, "de_Device");
var de_DeviceDescription = /* @__PURE__ */ __name((output, context) => {
  return (0, import_smithy_client.take)(output, {
    Arn: [, import_smithy_client.expectString, `arn`],
    Attributes: [, import_smithy_client._json, `attributes`],
    DeviceId: [, import_smithy_client.expectString, `deviceId`],
    Enabled: [, import_smithy_client.expectBoolean, `enabled`],
    RemainingLife: [, import_smithy_client.limitedParseDouble, `remainingLife`],
    Tags: [, import_smithy_client._json, `tags`],
    Type: [, import_smithy_client.expectString, `type`]
  });
}, "de_DeviceDescription");
var de_DeviceEvent = /* @__PURE__ */ __name((output, context) => {
  return (0, import_smithy_client.take)(output, {
    Device: [, (_) => de_Device(_, context), `device`],
    StdEvent: [, import_smithy_client.expectString, `stdEvent`]
  });
}, "de_DeviceEvent");
var de_DeviceMethod = /* @__PURE__ */ __name((output, context) => {
  return (0, import_smithy_client.take)(output, {
    DeviceType: [, import_smithy_client.expectString, `deviceType`],
    MethodName: [, import_smithy_client.expectString, `methodName`]
  });
}, "de_DeviceMethod");
var deserializeMetadata = /* @__PURE__ */ __name((output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
}), "deserializeMetadata");
var _DT = "DeviceType";
var _FTS = "FromTimeStamp";
var _MR = "MaxResults";
var _NT = "NextToken";
var _TK = "TagKeys";
var _TTS = "ToTimeStamp";
var _dT = "deviceType";
var _fTS = "fromTimeStamp";
var _mR = "maxResults";
var _nT = "nextToken";
var _tK = "tagKeys";
var _tTS = "toTimeStamp";

// src/commands/ClaimDevicesByClaimCodeCommand.ts
var ClaimDevicesByClaimCodeCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "ClaimDevicesByClaimCode", {}).n("IoT1ClickDevicesServiceClient", "ClaimDevicesByClaimCodeCommand").f(void 0, void 0).ser(se_ClaimDevicesByClaimCodeCommand).de(de_ClaimDevicesByClaimCodeCommand).build() {
  static {
    __name(this, "ClaimDevicesByClaimCodeCommand");
  }
};

// src/commands/DescribeDeviceCommand.ts



var DescribeDeviceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "DescribeDevice", {}).n("IoT1ClickDevicesServiceClient", "DescribeDeviceCommand").f(void 0, void 0).ser(se_DescribeDeviceCommand).de(de_DescribeDeviceCommand).build() {
  static {
    __name(this, "DescribeDeviceCommand");
  }
};

// src/commands/FinalizeDeviceClaimCommand.ts



var FinalizeDeviceClaimCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "FinalizeDeviceClaim", {}).n("IoT1ClickDevicesServiceClient", "FinalizeDeviceClaimCommand").f(void 0, void 0).ser(se_FinalizeDeviceClaimCommand).de(de_FinalizeDeviceClaimCommand).build() {
  static {
    __name(this, "FinalizeDeviceClaimCommand");
  }
};

// src/commands/GetDeviceMethodsCommand.ts



var GetDeviceMethodsCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "GetDeviceMethods", {}).n("IoT1ClickDevicesServiceClient", "GetDeviceMethodsCommand").f(void 0, void 0).ser(se_GetDeviceMethodsCommand).de(de_GetDeviceMethodsCommand).build() {
  static {
    __name(this, "GetDeviceMethodsCommand");
  }
};

// src/commands/InitiateDeviceClaimCommand.ts



var InitiateDeviceClaimCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "InitiateDeviceClaim", {}).n("IoT1ClickDevicesServiceClient", "InitiateDeviceClaimCommand").f(void 0, void 0).ser(se_InitiateDeviceClaimCommand).de(de_InitiateDeviceClaimCommand).build() {
  static {
    __name(this, "InitiateDeviceClaimCommand");
  }
};

// src/commands/InvokeDeviceMethodCommand.ts



var InvokeDeviceMethodCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "InvokeDeviceMethod", {}).n("IoT1ClickDevicesServiceClient", "InvokeDeviceMethodCommand").f(void 0, void 0).ser(se_InvokeDeviceMethodCommand).de(de_InvokeDeviceMethodCommand).build() {
  static {
    __name(this, "InvokeDeviceMethodCommand");
  }
};

// src/commands/ListDeviceEventsCommand.ts



var ListDeviceEventsCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "ListDeviceEvents", {}).n("IoT1ClickDevicesServiceClient", "ListDeviceEventsCommand").f(void 0, void 0).ser(se_ListDeviceEventsCommand).de(de_ListDeviceEventsCommand).build() {
  static {
    __name(this, "ListDeviceEventsCommand");
  }
};

// src/commands/ListDevicesCommand.ts



var ListDevicesCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "ListDevices", {}).n("IoT1ClickDevicesServiceClient", "ListDevicesCommand").f(void 0, void 0).ser(se_ListDevicesCommand).de(de_ListDevicesCommand).build() {
  static {
    __name(this, "ListDevicesCommand");
  }
};

// src/commands/ListTagsForResourceCommand.ts



var ListTagsForResourceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "ListTagsForResource", {}).n("IoT1ClickDevicesServiceClient", "ListTagsForResourceCommand").f(void 0, void 0).ser(se_ListTagsForResourceCommand).de(de_ListTagsForResourceCommand).build() {
  static {
    __name(this, "ListTagsForResourceCommand");
  }
};

// src/commands/TagResourceCommand.ts



var TagResourceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "TagResource", {}).n("IoT1ClickDevicesServiceClient", "TagResourceCommand").f(void 0, void 0).ser(se_TagResourceCommand).de(de_TagResourceCommand).build() {
  static {
    __name(this, "TagResourceCommand");
  }
};

// src/commands/UnclaimDeviceCommand.ts



var UnclaimDeviceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "UnclaimDevice", {}).n("IoT1ClickDevicesServiceClient", "UnclaimDeviceCommand").f(void 0, void 0).ser(se_UnclaimDeviceCommand).de(de_UnclaimDeviceCommand).build() {
  static {
    __name(this, "UnclaimDeviceCommand");
  }
};

// src/commands/UntagResourceCommand.ts



var UntagResourceCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "UntagResource", {}).n("IoT1ClickDevicesServiceClient", "UntagResourceCommand").f(void 0, void 0).ser(se_UntagResourceCommand).de(de_UntagResourceCommand).build() {
  static {
    __name(this, "UntagResourceCommand");
  }
};

// src/commands/UpdateDeviceStateCommand.ts



var UpdateDeviceStateCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("IoT1ClickDevicesService", "UpdateDeviceState", {}).n("IoT1ClickDevicesServiceClient", "UpdateDeviceStateCommand").f(void 0, void 0).ser(se_UpdateDeviceStateCommand).de(de_UpdateDeviceStateCommand).build() {
  static {
    __name(this, "UpdateDeviceStateCommand");
  }
};

// src/IoT1ClickDevicesService.ts
var commands = {
  ClaimDevicesByClaimCodeCommand,
  DescribeDeviceCommand,
  FinalizeDeviceClaimCommand,
  GetDeviceMethodsCommand,
  InitiateDeviceClaimCommand,
  InvokeDeviceMethodCommand,
  ListDeviceEventsCommand,
  ListDevicesCommand,
  ListTagsForResourceCommand,
  TagResourceCommand,
  UnclaimDeviceCommand,
  UntagResourceCommand,
  UpdateDeviceStateCommand
};
var IoT1ClickDevicesService = class extends IoT1ClickDevicesServiceClient {
  static {
    __name(this, "IoT1ClickDevicesService");
  }
};
(0, import_smithy_client.createAggregatedClient)(commands, IoT1ClickDevicesService);
// Annotate the CommonJS export names for ESM import in node:

0 && (module.exports = {
  IoT1ClickDevicesServiceServiceException,
  __Client,
  IoT1ClickDevicesServiceClient,
  IoT1ClickDevicesService,
  $Command,
  ClaimDevicesByClaimCodeCommand,
  DescribeDeviceCommand,
  FinalizeDeviceClaimCommand,
  GetDeviceMethodsCommand,
  InitiateDeviceClaimCommand,
  InvokeDeviceMethodCommand,
  ListDeviceEventsCommand,
  ListDevicesCommand,
  ListTagsForResourceCommand,
  TagResourceCommand,
  UnclaimDeviceCommand,
  UntagResourceCommand,
  UpdateDeviceStateCommand,
  ForbiddenException,
  InternalFailureException,
  InvalidRequestException,
  ResourceNotFoundException,
  PreconditionFailedException,
  ResourceConflictException,
  RangeNotSatisfiableException
});

