import { createAggregatedClient } from "@smithy/smithy-client";
import { ClaimDevicesByClaimCodeCommand, } from "./commands/ClaimDevicesByClaimCodeCommand";
import { DescribeDeviceCommand, } from "./commands/DescribeDeviceCommand";
import { FinalizeDeviceClaimCommand, } from "./commands/FinalizeDeviceClaimCommand";
import { GetDeviceMethodsCommand, } from "./commands/GetDeviceMethodsCommand";
import { InitiateDeviceClaimCommand, } from "./commands/InitiateDeviceClaimCommand";
import { InvokeDeviceMethodCommand, } from "./commands/InvokeDeviceMethodCommand";
import { ListDeviceEventsCommand, } from "./commands/ListDeviceEventsCommand";
import { ListDevicesCommand } from "./commands/ListDevicesCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UnclaimDeviceCommand, } from "./commands/UnclaimDeviceCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
import { UpdateDeviceStateCommand, } from "./commands/UpdateDeviceStateCommand";
import { IoT1ClickDevicesServiceClient } from "./IoT1ClickDevicesServiceClient";
const commands = {
    ClaimDevicesByClaimCodeCommand,
    DescribeDeviceCommand,
    FinalizeDeviceClaimCommand,
    GetDeviceMethodsCommand,
    InitiateDeviceClaimCommand,
    InvokeDeviceMethodCommand,
    ListDeviceEventsCommand,
    ListDevicesCommand,
    ListTagsForResourceCommand,
    TagResourceCommand,
    UnclaimDeviceCommand,
    UntagResourceCommand,
    UpdateDeviceStateCommand,
};
export class IoT1ClickDevicesService extends IoT1ClickDevicesServiceClient {
}
createAggregatedClient(commands, IoT1ClickDevicesService);
