import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_InitiateDeviceClaimCommand, se_InitiateDeviceClaimCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class InitiateDeviceClaimCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("IoT1ClickDevicesService", "InitiateDeviceClaim", {})
    .n("IoT1ClickDevicesServiceClient", "InitiateDeviceClaimCommand")
    .f(void 0, void 0)
    .ser(se_InitiateDeviceClaimCommand)
    .de(de_InitiateDeviceClaimCommand)
    .build() {
}
