import { loadRestJsonErrorCode, parseJsonBody as parseBody, parseJsonErrorBody as parseErrorBody } from "@aws-sdk/core";
import { requestBuilder as rb } from "@smithy/core";
import { _json, collectBody, decorateServiceException as __decorateServiceException, expectBoolean as __expectBoolean, expectInt32 as __expectInt32, expectNonNull as __expectNonNull, expectObject as __expectObject, expectString as __expectString, limitedParseDouble as __limitedParseDouble, map, serializeDateTime as __serializeDateTime, take, withBaseException, } from "@smithy/smithy-client";
import { IoT1ClickDevicesServiceServiceException as __BaseException } from "../models/IoT1ClickDevicesServiceServiceException";
import { ForbiddenException, InternalFailureException, InvalidRequestException, PreconditionFailedException, RangeNotSatisfiableException, ResourceConflictException, ResourceNotFoundException, } from "../models/models_0";
export const se_ClaimDevicesByClaimCodeCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/claims/{ClaimCode}");
    b.p("ClaimCode", () => input.ClaimCode, "{ClaimCode}", false);
    let body;
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_DescribeDeviceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/devices/{DeviceId}");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_FinalizeDeviceClaimCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/devices/{DeviceId}/finalize-claim");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    let body;
    body = JSON.stringify(take(input, {
        tags: [, (_) => _json(_), `Tags`],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_GetDeviceMethodsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/devices/{DeviceId}/methods");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_InitiateDeviceClaimCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/devices/{DeviceId}/initiate-claim");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    let body;
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_InvokeDeviceMethodCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/devices/{DeviceId}/methods");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    let body;
    body = JSON.stringify(take(input, {
        deviceMethod: [, (_) => se_DeviceMethod(_, context), `DeviceMethod`],
        deviceMethodParameters: [, , `DeviceMethodParameters`],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_ListDeviceEventsCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/devices/{DeviceId}/events");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    const query = map({
        [_fTS]: [
            __expectNonNull(input.FromTimeStamp, `FromTimeStamp`) != null,
            () => __serializeDateTime(input[_FTS]).toString(),
        ],
        [_mR]: [() => input.MaxResults !== void 0, () => input[_MR].toString()],
        [_nT]: [, input[_NT]],
        [_tTS]: [
            __expectNonNull(input.ToTimeStamp, `ToTimeStamp`) != null,
            () => __serializeDateTime(input[_TTS]).toString(),
        ],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListDevicesCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/devices");
    const query = map({
        [_dT]: [, input[_DT]],
        [_mR]: [() => input.MaxResults !== void 0, () => input[_MR].toString()],
        [_nT]: [, input[_NT]],
    });
    let body;
    b.m("GET").h(headers).q(query).b(body);
    return b.build();
};
export const se_ListTagsForResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/tags/{ResourceArn}");
    b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    let body;
    b.m("GET").h(headers).b(body);
    return b.build();
};
export const se_TagResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/tags/{ResourceArn}");
    b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    let body;
    body = JSON.stringify(take(input, {
        tags: [, (_) => _json(_), `Tags`],
    }));
    b.m("POST").h(headers).b(body);
    return b.build();
};
export const se_UnclaimDeviceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/devices/{DeviceId}/unclaim");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    let body;
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const se_UntagResourceCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {};
    b.bp("/tags/{ResourceArn}");
    b.p("ResourceArn", () => input.ResourceArn, "{ResourceArn}", false);
    const query = map({
        [_tK]: [__expectNonNull(input.TagKeys, `TagKeys`) != null, () => input[_TK] || []],
    });
    let body;
    b.m("DELETE").h(headers).q(query).b(body);
    return b.build();
};
export const se_UpdateDeviceStateCommand = async (input, context) => {
    const b = rb(input, context);
    const headers = {
        "content-type": "application/json",
    };
    b.bp("/devices/{DeviceId}/state");
    b.p("DeviceId", () => input.DeviceId, "{DeviceId}", false);
    let body;
    body = JSON.stringify(take(input, {
        enabled: [, , `Enabled`],
    }));
    b.m("PUT").h(headers).b(body);
    return b.build();
};
export const de_ClaimDevicesByClaimCodeCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        ClaimCode: [, __expectString, `claimCode`],
        Total: [, __expectInt32, `total`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_DescribeDeviceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        DeviceDescription: [, (_) => de_DeviceDescription(_, context), `deviceDescription`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_FinalizeDeviceClaimCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        State: [, __expectString, `state`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_GetDeviceMethodsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        DeviceMethods: [, (_) => de___listOfDeviceMethod(_, context), `deviceMethods`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_InitiateDeviceClaimCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        State: [, __expectString, `state`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_InvokeDeviceMethodCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        DeviceMethodResponse: [, __expectString, `deviceMethodResponse`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListDeviceEventsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Events: [, (_) => de___listOfDeviceEvent(_, context), `events`],
        NextToken: [, __expectString, `nextToken`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListDevicesCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Devices: [, (_) => de___listOfDeviceDescription(_, context), `devices`],
        NextToken: [, __expectString, `nextToken`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        Tags: [, _json, `tags`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_TagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_UnclaimDeviceCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    const data = __expectNonNull(__expectObject(await parseBody(output.body, context)), "body");
    const doc = take(data, {
        State: [, __expectString, `state`],
    });
    Object.assign(contents, doc);
    return contents;
};
export const de_UntagResourceCommand = async (output, context) => {
    if (output.statusCode !== 204 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
export const de_UpdateDeviceStateCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return de_CommandError(output, context);
    }
    const contents = map({
        $metadata: deserializeMetadata(output),
    });
    await collectBody(output.body, context);
    return contents;
};
const de_CommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ForbiddenException":
        case "com.amazonaws.iot1clickdevicesservice#ForbiddenException":
            throw await de_ForbiddenExceptionRes(parsedOutput, context);
        case "InternalFailureException":
        case "com.amazonaws.iot1clickdevicesservice#InternalFailureException":
            throw await de_InternalFailureExceptionRes(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.iot1clickdevicesservice#InvalidRequestException":
            throw await de_InvalidRequestExceptionRes(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.iot1clickdevicesservice#ResourceNotFoundException":
            throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
        case "PreconditionFailedException":
        case "com.amazonaws.iot1clickdevicesservice#PreconditionFailedException":
            throw await de_PreconditionFailedExceptionRes(parsedOutput, context);
        case "ResourceConflictException":
        case "com.amazonaws.iot1clickdevicesservice#ResourceConflictException":
            throw await de_ResourceConflictExceptionRes(parsedOutput, context);
        case "RangeNotSatisfiableException":
        case "com.amazonaws.iot1clickdevicesservice#RangeNotSatisfiableException":
            throw await de_RangeNotSatisfiableExceptionRes(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            return throwDefaultError({
                output,
                parsedBody,
                errorCode,
            });
    }
};
const throwDefaultError = withBaseException(__BaseException);
const de_ForbiddenExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Code: [, __expectString, `code`],
        Message: [, __expectString, `message`],
    });
    Object.assign(contents, doc);
    const exception = new ForbiddenException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_InternalFailureExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Code: [, __expectString, `code`],
        Message: [, __expectString, `message`],
    });
    Object.assign(contents, doc);
    const exception = new InternalFailureException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_InvalidRequestExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Code: [, __expectString, `code`],
        Message: [, __expectString, `message`],
    });
    Object.assign(contents, doc);
    const exception = new InvalidRequestException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_PreconditionFailedExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Code: [, __expectString, `code`],
        Message: [, __expectString, `message`],
    });
    Object.assign(contents, doc);
    const exception = new PreconditionFailedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_RangeNotSatisfiableExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Code: [, __expectString, `code`],
        Message: [, __expectString, `message`],
    });
    Object.assign(contents, doc);
    const exception = new RangeNotSatisfiableException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ResourceConflictExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Code: [, __expectString, `code`],
        Message: [, __expectString, `message`],
    });
    Object.assign(contents, doc);
    const exception = new ResourceConflictException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const de_ResourceNotFoundExceptionRes = async (parsedOutput, context) => {
    const contents = map({});
    const data = parsedOutput.body;
    const doc = take(data, {
        Code: [, __expectString, `code`],
        Message: [, __expectString, `message`],
    });
    Object.assign(contents, doc);
    const exception = new ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return __decorateServiceException(exception, parsedOutput.body);
};
const se_DeviceMethod = (input, context) => {
    return take(input, {
        deviceType: [, , `DeviceType`],
        methodName: [, , `MethodName`],
    });
};
const de___listOfDeviceDescription = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_DeviceDescription(entry, context);
    });
    return retVal;
};
const de___listOfDeviceEvent = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_DeviceEvent(entry, context);
    });
    return retVal;
};
const de___listOfDeviceMethod = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        return de_DeviceMethod(entry, context);
    });
    return retVal;
};
const de_Device = (output, context) => {
    return take(output, {
        Attributes: [, _json, `attributes`],
        DeviceId: [, __expectString, `deviceId`],
        Type: [, __expectString, `type`],
    });
};
const de_DeviceDescription = (output, context) => {
    return take(output, {
        Arn: [, __expectString, `arn`],
        Attributes: [, _json, `attributes`],
        DeviceId: [, __expectString, `deviceId`],
        Enabled: [, __expectBoolean, `enabled`],
        RemainingLife: [, __limitedParseDouble, `remainingLife`],
        Tags: [, _json, `tags`],
        Type: [, __expectString, `type`],
    });
};
const de_DeviceEvent = (output, context) => {
    return take(output, {
        Device: [, (_) => de_Device(_, context), `device`],
        StdEvent: [, __expectString, `stdEvent`],
    });
};
const de_DeviceMethod = (output, context) => {
    return take(output, {
        DeviceType: [, __expectString, `deviceType`],
        MethodName: [, __expectString, `methodName`],
    });
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const _DT = "DeviceType";
const _FTS = "FromTimeStamp";
const _MR = "MaxResults";
const _NT = "NextToken";
const _TK = "TagKeys";
const _TTS = "ToTimeStamp";
const _dT = "deviceType";
const _fTS = "fromTimeStamp";
const _mR = "maxResults";
const _nT = "nextToken";
const _tK = "tagKeys";
const _tTS = "toTimeStamp";
