import { AwsSdkSigV4AuthInputConfig, AwsSdkSigV4AuthResolvedConfig, AwsSdkSigV4PreviouslyResolved } from "@aws-sdk/core";
import { HandlerExecutionContext, HttpAuthScheme, HttpAuthSchemeParameters, HttpAuthSchemeParametersProvider, HttpAuthSchemeProvider } from "@smithy/types";
import { IoT1ClickDevicesServiceClientResolvedConfig } from "../IoT1ClickDevicesServiceClient";
/**
 * @internal
 */
export interface IoT1ClickDevicesServiceHttpAuthSchemeParameters extends HttpAuthSchemeParameters {
    region?: string;
}
/**
 * @internal
 */
export interface IoT1ClickDevicesServiceHttpAuthSchemeParametersProvider extends HttpAuthSchemeParametersProvider<IoT1ClickDevicesServiceClientResolvedConfig, HandlerExecutionContext, IoT1ClickDevicesServiceHttpAuthSchemeParameters, object> {
}
/**
 * @internal
 */
export declare const defaultIoT1ClickDevicesServiceHttpAuthSchemeParametersProvider: (config: IoT1ClickDevicesServiceClientResolvedConfig, context: HandlerExecutionContext, input: object) => Promise<IoT1ClickDevicesServiceHttpAuthSchemeParameters>;
/**
 * @internal
 */
export interface IoT1ClickDevicesServiceHttpAuthSchemeProvider extends HttpAuthSchemeProvider<IoT1ClickDevicesServiceHttpAuthSchemeParameters> {
}
/**
 * @internal
 */
export declare const defaultIoT1ClickDevicesServiceHttpAuthSchemeProvider: IoT1ClickDevicesServiceHttpAuthSchemeProvider;
/**
 * @internal
 */
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
    /**
     * Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    httpAuthSchemes?: HttpAuthScheme[];
    /**
     * Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    httpAuthSchemeProvider?: IoT1ClickDevicesServiceHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export interface HttpAuthSchemeResolvedConfig extends AwsSdkSigV4AuthResolvedConfig {
    /**
     * Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    readonly httpAuthSchemes: HttpAuthScheme[];
    /**
     * Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    readonly httpAuthSchemeProvider: IoT1ClickDevicesServiceHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export declare const resolveHttpAuthSchemeConfig: <T>(config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved) => T & HttpAuthSchemeResolvedConfig;
