import { HttpHandlerOptions as __HttpHandlerOptions } from "@smithy/types";
import {
  ClaimDevicesByClaimCodeCommandInput,
  ClaimDevicesByClaimCodeCommandOutput,
} from "./commands/ClaimDevicesByClaimCodeCommand";
import {
  DescribeDeviceCommandInput,
  DescribeDeviceCommandOutput,
} from "./commands/DescribeDeviceCommand";
import {
  FinalizeDeviceClaimCommandInput,
  FinalizeDeviceClaimCommandOutput,
} from "./commands/FinalizeDeviceClaimCommand";
import {
  GetDeviceMethodsCommandInput,
  GetDeviceMethodsCommandOutput,
} from "./commands/GetDeviceMethodsCommand";
import {
  InitiateDeviceClaimCommandInput,
  InitiateDeviceClaimCommandOutput,
} from "./commands/InitiateDeviceClaimCommand";
import {
  InvokeDeviceMethodCommandInput,
  InvokeDeviceMethodCommandOutput,
} from "./commands/InvokeDeviceMethodCommand";
import {
  ListDeviceEventsCommandInput,
  ListDeviceEventsCommandOutput,
} from "./commands/ListDeviceEventsCommand";
import {
  ListDevicesCommandInput,
  ListDevicesCommandOutput,
} from "./commands/ListDevicesCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  UnclaimDeviceCommandInput,
  UnclaimDeviceCommandOutput,
} from "./commands/UnclaimDeviceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateDeviceStateCommandInput,
  UpdateDeviceStateCommandOutput,
} from "./commands/UpdateDeviceStateCommand";
import { IoT1ClickDevicesServiceClient } from "./IoT1ClickDevicesServiceClient";
export interface IoT1ClickDevicesService {
  claimDevicesByClaimCode(
    args: ClaimDevicesByClaimCodeCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ClaimDevicesByClaimCodeCommandOutput>;
  claimDevicesByClaimCode(
    args: ClaimDevicesByClaimCodeCommandInput,
    cb: (err: any, data?: ClaimDevicesByClaimCodeCommandOutput) => void
  ): void;
  claimDevicesByClaimCode(
    args: ClaimDevicesByClaimCodeCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ClaimDevicesByClaimCodeCommandOutput) => void
  ): void;
  describeDevice(
    args: DescribeDeviceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeDeviceCommandOutput>;
  describeDevice(
    args: DescribeDeviceCommandInput,
    cb: (err: any, data?: DescribeDeviceCommandOutput) => void
  ): void;
  describeDevice(
    args: DescribeDeviceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeDeviceCommandOutput) => void
  ): void;
  finalizeDeviceClaim(
    args: FinalizeDeviceClaimCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<FinalizeDeviceClaimCommandOutput>;
  finalizeDeviceClaim(
    args: FinalizeDeviceClaimCommandInput,
    cb: (err: any, data?: FinalizeDeviceClaimCommandOutput) => void
  ): void;
  finalizeDeviceClaim(
    args: FinalizeDeviceClaimCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: FinalizeDeviceClaimCommandOutput) => void
  ): void;
  getDeviceMethods(
    args: GetDeviceMethodsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetDeviceMethodsCommandOutput>;
  getDeviceMethods(
    args: GetDeviceMethodsCommandInput,
    cb: (err: any, data?: GetDeviceMethodsCommandOutput) => void
  ): void;
  getDeviceMethods(
    args: GetDeviceMethodsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetDeviceMethodsCommandOutput) => void
  ): void;
  initiateDeviceClaim(
    args: InitiateDeviceClaimCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<InitiateDeviceClaimCommandOutput>;
  initiateDeviceClaim(
    args: InitiateDeviceClaimCommandInput,
    cb: (err: any, data?: InitiateDeviceClaimCommandOutput) => void
  ): void;
  initiateDeviceClaim(
    args: InitiateDeviceClaimCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: InitiateDeviceClaimCommandOutput) => void
  ): void;
  invokeDeviceMethod(
    args: InvokeDeviceMethodCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<InvokeDeviceMethodCommandOutput>;
  invokeDeviceMethod(
    args: InvokeDeviceMethodCommandInput,
    cb: (err: any, data?: InvokeDeviceMethodCommandOutput) => void
  ): void;
  invokeDeviceMethod(
    args: InvokeDeviceMethodCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: InvokeDeviceMethodCommandOutput) => void
  ): void;
  listDeviceEvents(
    args: ListDeviceEventsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListDeviceEventsCommandOutput>;
  listDeviceEvents(
    args: ListDeviceEventsCommandInput,
    cb: (err: any, data?: ListDeviceEventsCommandOutput) => void
  ): void;
  listDeviceEvents(
    args: ListDeviceEventsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListDeviceEventsCommandOutput) => void
  ): void;
  listDevices(): Promise<ListDevicesCommandOutput>;
  listDevices(
    args: ListDevicesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListDevicesCommandOutput>;
  listDevices(
    args: ListDevicesCommandInput,
    cb: (err: any, data?: ListDevicesCommandOutput) => void
  ): void;
  listDevices(
    args: ListDevicesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListDevicesCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListTagsForResourceCommandOutput>;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TagResourceCommandOutput>;
  tagResource(
    args: TagResourceCommandInput,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  unclaimDevice(
    args: UnclaimDeviceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UnclaimDeviceCommandOutput>;
  unclaimDevice(
    args: UnclaimDeviceCommandInput,
    cb: (err: any, data?: UnclaimDeviceCommandOutput) => void
  ): void;
  unclaimDevice(
    args: UnclaimDeviceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UnclaimDeviceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UntagResourceCommandOutput>;
  untagResource(
    args: UntagResourceCommandInput,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  updateDeviceState(
    args: UpdateDeviceStateCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateDeviceStateCommandOutput>;
  updateDeviceState(
    args: UpdateDeviceStateCommandInput,
    cb: (err: any, data?: UpdateDeviceStateCommandOutput) => void
  ): void;
  updateDeviceState(
    args: UpdateDeviceStateCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateDeviceStateCommandOutput) => void
  ): void;
}
export declare class IoT1ClickDevicesService
  extends IoT1ClickDevicesServiceClient
  implements IoT1ClickDevicesService {}
