import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { IoT1ClickDevicesServiceClientResolvedConfig } from "../IoT1ClickDevicesServiceClient";
export interface IoT1ClickDevicesServiceHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface IoT1ClickDevicesServiceHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    IoT1ClickDevicesServiceClientResolvedConfig,
    HandlerExecutionContext,
    IoT1ClickDevicesServiceHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultIoT1ClickDevicesServiceHttpAuthSchemeParametersProvider: (
  config: IoT1ClickDevicesServiceClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<IoT1ClickDevicesServiceHttpAuthSchemeParameters>;
export interface IoT1ClickDevicesServiceHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<IoT1ClickDevicesServiceHttpAuthSchemeParameters> {}
export declare const defaultIoT1ClickDevicesServiceHttpAuthSchemeProvider: IoT1ClickDevicesServiceHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: IoT1ClickDevicesServiceHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: IoT1ClickDevicesServiceHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
