import { ExceptionOptionType as __ExceptionOptionType } from "@smithy/smithy-client";
import { IoT1ClickDevicesServiceServiceException as __BaseException } from "./IoT1ClickDevicesServiceServiceException";
export interface DeviceDescription {
  Arn?: string | undefined;
  Attributes?: Record<string, string> | undefined;
  DeviceId?: string | undefined;
  Enabled?: boolean | undefined;
  RemainingLife?: number | undefined;
  Type?: string | undefined;
  Tags?: Record<string, string> | undefined;
}
export interface Attributes {}
export interface Device {
  Attributes?: Attributes | undefined;
  DeviceId?: string | undefined;
  Type?: string | undefined;
}
export interface DeviceEvent {
  Device?: Device | undefined;
  StdEvent?: string | undefined;
}
export interface DeviceMethod {
  DeviceType?: string | undefined;
  MethodName?: string | undefined;
}
export interface ClaimDevicesByClaimCodeRequest {
  ClaimCode: string | undefined;
}
export interface ClaimDevicesByClaimCodeResponse {
  ClaimCode?: string | undefined;
  Total?: number | undefined;
}
export declare class ForbiddenException extends __BaseException {
  readonly name: "ForbiddenException";
  readonly $fault: "client";
  Code?: string | undefined;
  Message?: string | undefined;
  constructor(opts: __ExceptionOptionType<ForbiddenException, __BaseException>);
}
export declare class InternalFailureException extends __BaseException {
  readonly name: "InternalFailureException";
  readonly $fault: "server";
  Code?: string | undefined;
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<InternalFailureException, __BaseException>
  );
}
export declare class InvalidRequestException extends __BaseException {
  readonly name: "InvalidRequestException";
  readonly $fault: "client";
  Code?: string | undefined;
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<InvalidRequestException, __BaseException>
  );
}
export interface DescribeDeviceRequest {
  DeviceId: string | undefined;
}
export interface DescribeDeviceResponse {
  DeviceDescription?: DeviceDescription | undefined;
}
export declare class ResourceNotFoundException extends __BaseException {
  readonly name: "ResourceNotFoundException";
  readonly $fault: "client";
  Code?: string | undefined;
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<ResourceNotFoundException, __BaseException>
  );
}
export interface FinalizeDeviceClaimRequest {
  DeviceId: string | undefined;
  Tags?: Record<string, string> | undefined;
}
export interface FinalizeDeviceClaimResponse {
  State?: string | undefined;
}
export declare class PreconditionFailedException extends __BaseException {
  readonly name: "PreconditionFailedException";
  readonly $fault: "client";
  Code?: string | undefined;
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<PreconditionFailedException, __BaseException>
  );
}
export declare class ResourceConflictException extends __BaseException {
  readonly name: "ResourceConflictException";
  readonly $fault: "client";
  Code?: string | undefined;
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<ResourceConflictException, __BaseException>
  );
}
export interface GetDeviceMethodsRequest {
  DeviceId: string | undefined;
}
export interface GetDeviceMethodsResponse {
  DeviceMethods?: DeviceMethod[] | undefined;
}
export interface InitiateDeviceClaimRequest {
  DeviceId: string | undefined;
}
export interface InitiateDeviceClaimResponse {
  State?: string | undefined;
}
export interface InvokeDeviceMethodRequest {
  DeviceId: string | undefined;
  DeviceMethod?: DeviceMethod | undefined;
  DeviceMethodParameters?: string | undefined;
}
export interface InvokeDeviceMethodResponse {
  DeviceMethodResponse?: string | undefined;
}
export declare class RangeNotSatisfiableException extends __BaseException {
  readonly name: "RangeNotSatisfiableException";
  readonly $fault: "client";
  Code?: string | undefined;
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<RangeNotSatisfiableException, __BaseException>
  );
}
export interface ListDeviceEventsRequest {
  DeviceId: string | undefined;
  FromTimeStamp: Date | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
  ToTimeStamp: Date | undefined;
}
export interface ListDeviceEventsResponse {
  Events?: DeviceEvent[] | undefined;
  NextToken?: string | undefined;
}
export interface ListDevicesRequest {
  DeviceType?: string | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface ListDevicesResponse {
  Devices?: DeviceDescription[] | undefined;
  NextToken?: string | undefined;
}
export interface ListTagsForResourceRequest {
  ResourceArn: string | undefined;
}
export interface ListTagsForResourceResponse {
  Tags?: Record<string, string> | undefined;
}
export interface TagResourceRequest {
  ResourceArn: string | undefined;
  Tags: Record<string, string> | undefined;
}
export interface UnclaimDeviceRequest {
  DeviceId: string | undefined;
}
export interface UnclaimDeviceResponse {
  State?: string | undefined;
}
export interface UntagResourceRequest {
  ResourceArn: string | undefined;
  TagKeys: string[] | undefined;
}
export interface UpdateDeviceStateRequest {
  DeviceId: string | undefined;
  Enabled?: boolean | undefined;
}
export interface UpdateDeviceStateResponse {}
