import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  ClaimDevicesByClaimCodeCommandInput,
  ClaimDevicesByClaimCodeCommandOutput,
} from "../commands/ClaimDevicesByClaimCodeCommand";
import {
  DescribeDeviceCommandInput,
  DescribeDeviceCommandOutput,
} from "../commands/DescribeDeviceCommand";
import {
  FinalizeDeviceClaimCommandInput,
  FinalizeDeviceClaimCommandOutput,
} from "../commands/FinalizeDeviceClaimCommand";
import {
  GetDeviceMethodsCommandInput,
  GetDeviceMethodsCommandOutput,
} from "../commands/GetDeviceMethodsCommand";
import {
  InitiateDeviceClaimCommandInput,
  InitiateDeviceClaimCommandOutput,
} from "../commands/InitiateDeviceClaimCommand";
import {
  InvokeDeviceMethodCommandInput,
  InvokeDeviceMethodCommandOutput,
} from "../commands/InvokeDeviceMethodCommand";
import {
  ListDeviceEventsCommandInput,
  ListDeviceEventsCommandOutput,
} from "../commands/ListDeviceEventsCommand";
import {
  ListDevicesCommandInput,
  ListDevicesCommandOutput,
} from "../commands/ListDevicesCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "../commands/ListTagsForResourceCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  UnclaimDeviceCommandInput,
  UnclaimDeviceCommandOutput,
} from "../commands/UnclaimDeviceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
import {
  UpdateDeviceStateCommandInput,
  UpdateDeviceStateCommandOutput,
} from "../commands/UpdateDeviceStateCommand";
export declare const se_ClaimDevicesByClaimCodeCommand: (
  input: ClaimDevicesByClaimCodeCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeDeviceCommand: (
  input: DescribeDeviceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_FinalizeDeviceClaimCommand: (
  input: FinalizeDeviceClaimCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDeviceMethodsCommand: (
  input: GetDeviceMethodsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_InitiateDeviceClaimCommand: (
  input: InitiateDeviceClaimCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_InvokeDeviceMethodCommand: (
  input: InvokeDeviceMethodCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListDeviceEventsCommand: (
  input: ListDeviceEventsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListDevicesCommand: (
  input: ListDevicesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTagsForResourceCommand: (
  input: ListTagsForResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UnclaimDeviceCommand: (
  input: UnclaimDeviceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateDeviceStateCommand: (
  input: UpdateDeviceStateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_ClaimDevicesByClaimCodeCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ClaimDevicesByClaimCodeCommandOutput>;
export declare const de_DescribeDeviceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeDeviceCommandOutput>;
export declare const de_FinalizeDeviceClaimCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<FinalizeDeviceClaimCommandOutput>;
export declare const de_GetDeviceMethodsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDeviceMethodsCommandOutput>;
export declare const de_InitiateDeviceClaimCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<InitiateDeviceClaimCommandOutput>;
export declare const de_InvokeDeviceMethodCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<InvokeDeviceMethodCommandOutput>;
export declare const de_ListDeviceEventsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListDeviceEventsCommandOutput>;
export declare const de_ListDevicesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListDevicesCommandOutput>;
export declare const de_ListTagsForResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTagsForResourceCommandOutput>;
export declare const de_TagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const de_UnclaimDeviceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UnclaimDeviceCommandOutput>;
export declare const de_UntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
export declare const de_UpdateDeviceStateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateDeviceStateCommandOutput>;
